﻿using System.Collections.Generic;

namespace TestLibrary
{
    /// <summary>
    /// 항목 공급자 인터페이스
    /// </summary>
    /// <typeparam name="TItem">항목 타입</typeparam>
    public interface IItemProvider<TItem>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method

        #region 카운트 가져오기 - FetchCount()

        /// <summary>
        /// 카운트 가져오기
        /// </summary>
        /// <returns>항목 수</returns>
        /// <remarks>이용 가능한 전체 항목 수를 가져온다.</remarks>
        int FetchCount();

        #endregion
        #region 범위 가져오기 - FetchRange(startIndex, pageCount, overallCount)

        /// <summary>
        /// 범위 가져오기
        /// </summary>
        /// <param name="startIndex">시작 인덱스</param>
        /// <param name="pageCount">페이지 수</param>
        /// <param name="overallCount">전체 수</param>
        /// <returns>항목 리스트</returns>
        IList<TItem> FetchRange(int startIndex, int pageCount, out int overallCount);

        #endregion
    }
}