﻿using System;
using System.ComponentModel;

namespace TestProject
{
	/// <summary>
	/// 고객
	/// </summary>
	public partial class Customer : INotifyPropertyChanging, INotifyPropertyChanged
	{
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 속성 변경 전 - PropertyChanging

        /// <summary>
        /// 속성 변경 전
        /// </summary>
        public event PropertyChangingEventHandler PropertyChanging;
		
		#endregion
		#region 속성 변경 후 - PropertyChanged

		/// <summary>
		/// 속성 변경 후
		/// </summary>
		public event PropertyChangedEventHandler PropertyChanged;

		#endregion

		//////////////////////////////////////////////////////////////////////////////////////////////////// Field
		////////////////////////////////////////////////////////////////////////////////////////// Static
		//////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 빈 속성 변경 전 이벤트 인자
        /// </summary>
        private static PropertyChangingEventArgs _emptyPropertyChangingEventArgs = new PropertyChangingEventArgs(string.Empty);

		#endregion

		////////////////////////////////////////////////////////////////////////////////////////// Instance
		//////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ID
        /// </summary>
        private int id;
		
		/// <summary>
		/// 이름
		/// </summary>
		private string firstName;
		
		/// <summary>
		/// 성
		/// </summary>
		private string lastName;
		
		/// <summary>
		/// 가입일
		/// </summary>
		private System.DateTime customerSince;
		
		/// <summary>
		/// 지역 호출 지불액
		/// </summary>
		private double amountPaidLocalCalls;
		
		/// <summary>
		/// 국내 호출 지불액
		/// </summary>
		private double amountPaidNationalCalls;
		
		/// <summary>
		/// 해외 호출 지불액
		/// </summary>
		private double amountPaidInternationalCalls;
		
		/// <summary>
		/// 계획상 패밀리 멤버 수
		/// </summary>
		private int numberFamilyMembersInPlan;
		
		/// <summary>
		/// 선호 프로그램 가입 여부
		/// </summary>
		private bool joinedPreferredProgram;
		
		/// <summary>
		/// 지역
		/// </summary>
		private int region;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ID - Id

        /// <summary>
        /// ID
        /// </summary>
        public int Id
		{
			get
			{
				return this.id;
			}
			set
			{
				if(this.id != value)
				{
					FirePropertyChangingEvent();

					this.id = value;

					FirePropertyChangedEvent("Id");
				}
			}
		}

        #endregion
		#region 이름 - FirstName

		/// <summary>
		/// 이름
		/// </summary>
        public string FirstName
		{
			get
			{
				return this.firstName;
			}
			set
			{
				if(this.firstName != value)
				{
					FirePropertyChangingEvent();

					this.firstName = value;

					FirePropertyChangedEvent("FirstName");
				}
			}
		}

        #endregion
        #region 성 - LastName

        /// <summary>
        /// 성
        /// </summary>
        public string LastName
		{
			get
			{
				return this.lastName;
			}
			set
			{
				if(this.lastName != value)
				{
					FirePropertyChangingEvent();

					this.lastName = value;

					FirePropertyChangedEvent("LastName");
				}
			}
		}

        #endregion
        #region 가입일 - CustomerSince

        /// <summary>
        /// 가입일
        /// </summary>
        public DateTime CustomerSince
		{
			get
			{
				return this.customerSince;
			}
			set
			{
				if(this.customerSince != value)
				{
					FirePropertyChangingEvent();

					this.customerSince = value;

					FirePropertyChangedEvent("CustomerSince");
				}
			}
		}

        #endregion
        #region 지역 호출 지불액 - AmountPaidLocalCalls

        /// <summary>
        /// 지역 호출 지불액
        /// </summary>
        public double AmountPaidLocalCalls
		{
			get
			{
				return this.amountPaidLocalCalls;
			}
			set
			{
				if(this.amountPaidLocalCalls != value)
				{
					FirePropertyChangingEvent();

					this.amountPaidLocalCalls = value;

					FirePropertyChangedEvent("AmountPaidLocalCalls");
				}
			}
		}

        #endregion
        #region 국내 호출 지불액 - AmountPaidNationalCalls

        /// <summary>
        /// 국내 호출 지불액
        /// </summary>
        public double AmountPaidNationalCalls
		{
			get
			{
				return this.amountPaidNationalCalls;
			}
			set
			{
				if(this.amountPaidNationalCalls != value)
				{
					FirePropertyChangingEvent();

					this.amountPaidNationalCalls = value;

					FirePropertyChangedEvent("AmountPaidNationalCalls");
				}
			}
		}

        #endregion
        #region 해외 호출 지불액 - AmountPaidInternationalCalls

        /// <summary>
        /// 해외 호출 지불액
        /// </summary>
        public double AmountPaidInternationalCalls
		{
			get
			{
				return this.amountPaidInternationalCalls;
			}
			set
			{
				if(this.amountPaidInternationalCalls != value)
				{
					FirePropertyChangingEvent();

					this.amountPaidInternationalCalls = value;

					FirePropertyChangedEvent("AmountPaidInternationalCalls");
				}
			}
		}

        #endregion
        #region 계획상 패밀리 멤버 수 - NumberFamilyMembersInPlan

        /// <summary>
        /// 계획상 패밀리 멤버 수
        /// </summary>
        public int NumberFamilyMembersInPlan
		{
			get
			{
				return this.numberFamilyMembersInPlan;
			}
			set
			{
				if((this.numberFamilyMembersInPlan != value))
				{
					FirePropertyChangingEvent();

					this.numberFamilyMembersInPlan = value;

					FirePropertyChangedEvent("NumberFamilyMembersInPlan");
				}
			}
		}

        #endregion
        #region 선호 프로그램 가입 여부 - JoinedPreferredProgram

        /// <summary>
        /// 선호 프로그램 가입 여부
        /// </summary>
        public bool JoinedPreferredProgram
		{
			get
			{
				return this.joinedPreferredProgram;
			}
			set
			{
				if(this.joinedPreferredProgram != value)
				{
					FirePropertyChangingEvent();

					this.joinedPreferredProgram = value;

					FirePropertyChangedEvent("JoinedPreferredProgram");
				}
			}
		}

        #endregion
        #region 지역 - Region

        /// <summary>
        /// 지역
        /// </summary>
        public int Region
		{
			get
			{
				return this.region;
			}
			set
			{
				if(this.region != value)
				{
					FirePropertyChangingEvent();

					this.region = value;

					FirePropertyChangedEvent("Region");
				}
			}
		}

		#endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Customer()

        /// <summary>
        /// 생성자
        /// </summary>
        public Customer()
		{
		}

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 속성 변경 전 이벤트 발생시키기 - FirePropertyChangingEvent()

        /// <summary>
        /// 속성 변경 전 이벤트 발생시키기
        /// </summary>
        protected virtual void FirePropertyChangingEvent()
		{
            PropertyChanging?.Invoke(this, _emptyPropertyChangingEventArgs);
        }

        #endregion
        #region 속성 변경 후 이벤트 발생시키기 - FirePropertyChangedEvent(propertyName)

        /// <summary>
        /// 속성 변경 후 이벤트 발생시키기
        /// </summary>
        /// <param name="propertyName">속성명</param>
        protected virtual void FirePropertyChangedEvent(string propertyName)
		{
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

		#endregion
	}
}