﻿using System.Windows.Controls;
using System.Windows.Data;

namespace TestProject
{
    /// <summary>
    /// 데이터 그리드 헬퍼
    /// </summary>
    public static class DataGridHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 정렬 멤버 경로 구하기 - GetSortMemberPath(column)

        /// <summary>
        /// 정렬 멤버 경로 구하기
        /// </summary>
        /// <param name="column">컬럼</param>
        /// <returns>정렬 멤버 경로</returns>
        public static string GetSortMemberPath(DataGridColumn column)
        {
            string sortPropertyName = column.SortMemberPath;

            if(string.IsNullOrEmpty(sortPropertyName))
            {
                DataGridBoundColumn boundColumn = column as DataGridBoundColumn;

                if(boundColumn != null)
                {
                    Binding binding = boundColumn.Binding as Binding;

                    if(binding != null)
                    {
                        if(!string.IsNullOrEmpty(binding.XPath))
                        {
                            sortPropertyName = binding.XPath;
                        }
                        else if(binding.Path != null)
                        {
                            sortPropertyName = binding.Path.Path;
                        }
                    }
                }
            }

            return sortPropertyName;
        }

        #endregion
    }
}